spec:
  inputs:
    deploy_stage:
      description: Stage where the review deployment will run
    cleanup_stage:
      description: Stage where the job that stops the review environment will run
    environment:
      default: review/$CI_COMMIT_REF_NAME
      description: The environment name where to perform the deployment
---
include:
  - local: common/ecs-base.yml
    inputs:
      registry_host: $CI_TEMPLATE_REGISTRY_HOST

review_ecs:
  stage: $[[ inputs.deploy_stage ]]
  extends: .deploy_to_ecs
  after_script:
    - echo "http://$(ecs get-task-hostname)" > environment_url.txt
  artifacts:
    paths:
      - environment_url.txt
  environment:
    name: $[[ inputs.environment ]]
    on_stop: stop_review_ecs
  rules:
#    - if: '$AUTO_DEVOPS_PLATFORM_TARGET != "ECS"' # or fargate!
#      when: never
#    - if: '$CI_KUBERNETES_ACTIVE || $KUBECONFIG'
#      when: never
#    - if: '$REVIEW_DISABLED'
#      when: never
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_MERGE_REQUEST_IID'

stop_review_ecs:
  extends: .ecs_image
  stage: $[[ inputs.cleanup_stage ]]
  allow_failure: true
  script:
    - ecs stop-task
  environment:
    name: $[[ inputs.environment ]]
    action: stop
  rules:
#    - if: '$AUTO_DEVOPS_PLATFORM_TARGET != "ECS"' # or fagate!
#      when: never
#    - if: '$CI_KUBERNETES_ACTIVE || $KUBECONFIG'
#      when: never
#    - if: '$REVIEW_DISABLED'
#      when: never
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_MERGE_REQUEST_IID'
      when: manual